#+CMU
(progn
  (let ((so-file (ext:unix-namestring (merge-pathnames "null.so" *load-truename*) nil)))
    (unless (probe-file (merge-pathnames "null.so" *load-truename*))
      (ext:run-program "/bin/sh" (list "-c"
                                          (format nil "gcc -shared -o ~A `pkg-config cairo --libs`"
                                                  so-file))))
    (ext:load-foreign so-file)))

#+SBCL
(progn
  (let ((so-file (sb-int:unix-namestring (merge-pathnames "null.so" *load-truename*) nil)))
    (unless (probe-file (merge-pathnames "null.so" *load-truename*))
      (sb-ext:run-program "/bin/sh" (list "-c"
                                          (format nil "gcc -shared -o ~A `pkg-config cairo --libs`"
                                                  so-file))))
    (sb-alien:load-shared-object so-file)))

